#ifndef  _My_class_h
#define  _My_class_h

#include <string>

class My_class { // 'inline' is for compactness only!
private:
	// 'std::is_trivially_copyable<My_class>: false':
	// 'std::is_trivially_assignable<My_class, My_class>': false:
	// 'std::is_trivially_move_constructible<My_class>': false:
	std::string _resource;
	// To prevent verbose writing of 'My_class::My_class() {}' in '.cpp' file:
	My_class() = default; // 'std::is_trivially_constructible<My_class>': false
public:

	// 'std::is_constructible<My_class, std::string>': true':

	inline My_class(std::string s) : _resource(s) {
	};

	// 'std::is_copy_constructible<My_class>': false:
	// 'std::is_assignable<My_class, My_class>': false:
	// 'std::is_move_constructible<My_class, My_class>': true:

	inline My_class(My_class&& mc) : _resource(std::move(mc._resource)) {
	}

	My_class(const My_class&) = delete; // 'std::is_copy_constructible<My_class>': false && 'std::is_move_constructible<My_class, My_class>': false
	My_class& operator=(const My_class&) = delete; // 'std::is_assignable<My_class, My_class>': false

	// 'std::is_assignable<My_class, My_class>': true:

	inline My_class& operator=(My_class&& mc) { // Move assignment
		_resource = std::move(mc._resource);
		return *this;
	};
	// To prevent verbose writing of 'My_class::~My_class() {}' in '.cpp' file:
	virtual ~My_class() = default; // Polymorphic type => !triviality
};

#endif
